export declare enum Priority {
    VeryLow = -2,
    Moderate = -1,
    Normal = 0,
    High = 1,
    Emergency = 2,
}
export interface IVerifyResult {
    valid: boolean;
    remainingCalls?: number;
    remainingCallsResetDate?: number;
}
export interface IRetrieveTokenResult {
    token: string;
    url: string;
    remainingCalls?: number;
    remainingCallsResetDate?: number;
}
export interface IRetrieveApikeyResult {
    apikey: string;
    remainingCalls?: number;
    remainingCallsResetDate?: number;
}
export interface IAddResult {
    remainingCalls: number;
    remainingCallsResetDate: number;
}
export interface IAddParameters {
    apiKey: string;
    providerKey?: string;
    priority?: Priority;
    url?: string;
    application: string;
    event: string;
    description: string;
}
export default class Prowl {
    private apiEndpoint;
    constructor(apiEndpoint?: string);
    getApiEndpoint(): string;
    add(parameters: IAddParameters): Promise<IAddResult>;
    verify(apiKey: string, providerKey?: string): Promise<IVerifyResult>;
    retrieveToken(providerKey: string): Promise<IRetrieveTokenResult>;
    retrieveApikey(providerKey: string, token: string): Promise<{
        apikey: any;
        remainingCalls: number;
        remainingCallsResetDate: number;
    }>;
    private doRequest(endpoint, method, data);
}
